<?php

// Initializations of the variables used
$result = array();

// MYSQL connection credentials
define('MYSQL_HOST'     , '');
define('MYSQL_USER'     , '');
define('MYSQL_PASSWORD' , '');
define('MYSQL_DB'       , '');

// PDO - connect to the database
try 
{
	$dbh = new PDO('mysql:host='.MYSQL_HOST.';dbname='.MYSQL_DB, MYSQL_USER, MYSQL_PASSWORD);

	$dbh->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
	$dbh->setAttribute(PDO::ATTR_PERSISTENT, true);
	$dbh->setAttribute(PDO::ATTR_EMULATE_PREPARES, true);
	$dbh->setAttribute(PDO::MYSQL_ATTR_USE_BUFFERED_QUERY, true);
} 
catch (PDOException $e) 
{
	echo 'Error!: ' . $e->getMessage() . '<br/>';
}


function get_coordinates($zipcode)
{
	$the_result = array();
	
	$url = "http://maps.googleapis.com/maps/api/geocode/xml?address=" . urlencode($zipcode.",FR") . "&sensor=true";
	$xml = simplexml_load_file($url);
	$the_result['LONGITUDE'] 	= '';
	$the_result['LATITUDE'] 	= '';
	if($xml->result->geometry->location->lng)
	{
		$the_result['LONGITUDE'] 	= (string) $xml->result->geometry->location->lng[0];
	}
	if($xml->result->geometry->location->lat)
	{
		$the_result['LATITUDE'] 	= (string) $xml->result->geometry->location->lat[0];
	}
		
	return $the_result;
}


// take the estates from the table named "Estates"
if(isset($_POST['zipcode']) && isset($_POST['radius']))
{
	$estates_results = array();
	
	$zipcode	= filter_var($_POST['zipcode']	, FILTER_SANITIZE_STRING);  
	$radius		= filter_var($_POST['radius']	, FILTER_VALIDATE_INT); 
	$med_lat 	= 0;
	$med_long 	= 0;
	
	$estate_coordinates = get_coordinates($zipcode);
	$long = $estate_coordinates['LONGITUDE'];
	$lat = $estate_coordinates['LATITUDE'];
	
	if($long && $lat)
	{
		$query	= "
					SELECT 
						estate_lat,
						estate_long,
						estate_name,
						estate_zipcode,
						((ACOS(SIN( ".$lat." * PI() / 180) * SIN(estate_lat * PI() / 180) + COS(".$lat." * PI() / 180) * COS(estate_lat * PI() / 180) * COS((".$long." - estate_long) * PI() / 180)) * 180 / PI()) * 60 * 1.1515) AS distance 
					FROM 
						Estates 
					HAVING 
						distance <= " . $radius . "
					";
		$stmt = $dbh->prepare($query);
		try
		{
			$stmt->bindParam(':minprice', $minprice);
			$stmt->bindParam(':maxprice', $maxprice);
			$stmt->execute();
		}
		catch (PDOException $e)
		{
			print($e->getMessage());
			die;
		}
		while($row = $stmt->fetch(PDO::FETCH_ASSOC))
		{
			$estates_results[] = $row;
		}
		if(count($estates_results))
		{
			foreach($estates_results as $key=>$value)
			{
				$med_lat += $value['estate_lat'];
				$med_long += $value['estate_long'];
			}
			$result[0] = $estates_results;
			$result[1] = $med_lat/count($estates_results);
			$result[2] = $med_long/count($estates_results);
		}
		else
		{
			$result[0] = 'none';
		}
	}
}
echo json_encode($result);


?>